### Encoding: latin1

### Name: Summary
### Title: Summaries of bit vectors
### Aliases: all.bit any.bit min.bit max.bit range.bit sum.bit summary.bit
### Keywords: classes logic

### ** Examples

  x <- as.bit(c(TRUE, TRUE))
  all(x)
  any(x)
  min(x)
  max(x)
  range(x)
  sum(x)
  summary(x)

 ## Not run: 
##D     n <- .Machine$integer.max
##D     x <- !bit(n)
##D     N <- 1000000L  # batchsize
##D     B <- n 
##D     R <- n 
##D 
##D     cat("Batched sum (52.5 sec on Centrino duo)\n")
##D     system.time({
##D       s <- 0L
##D       for (b in 1:B){
##D         s <- s + sum(x[((b-1L)*N+1L):(b*N)])
##D       }
##D       if (R)
##D         s <- s + sum(x[(n-R+1L):n])
##D     })
##D 
##D     cat("Batched sum saving repeated memory allocation for the return vector (44.4 sec on Centrino duo)\n")
##D     system.time({
##D       s <- 0L
##D       l <- logical(N)
##D       for (b in 1:B){
##D         .Call("R_bit_extract", x, ((b-1L)*N+1L):(b*N), l, PACKAGE = "bit")
##D         s <- s + sum(l)
##D       }
##D       if (R)
##D         s <- s + sum(x[(n-R+1L):n])
##D     })
##D 
##D     cat("C-coded sum (3.1 sec on Centrino duo)\n")
##D     system.time(sum(x))
##D  
## End(Not run)



